/*
 * @lc app=leetcode.cn id=10 lang=java
 *
 * [10] 正则表达式匹配
 *
 * https://leetcode-cn.com/problems/regular-expression-matching/description/
 *
 * algorithms
 * Hard (23.04%)
 * Likes:    485
 * Dislikes: 0
 * Total Accepted:    17.1K
 * Total Submissions: 74K
 * Testcase Example:  '"aa"\n"a"'
 *
 * 给你一个字符串 s 和一个字符规律 p，请你来实现一个支持 '.' 和 '*' 的正则表达式匹配。
 * 
 * '.' 匹配任意单个字符
 * '*' 匹配零个或多个前面的那一个元素
 * 
 * 
 * 所谓匹配，是要涵盖 整个 字符串 s的，而不是部分字符串。
 * 
 * 说明:
 * 
 * 
 * s 可能为空，且只包含从 a-z 的小写字母。
 * p 可能为空，且只包含从 a-z 的小写字母，以及字符 . 和 *。
 * 
 * 
 * 示例 1:
 * 
 * 输入:
 * s = "aa"
 * p = "a"
 * 输出: false
 * 解释: "a" 无法匹配 "aa" 整个字符串。
 * 
 * 
 * 示例 2:
 * 
 * 输入:
 * s = "aa"
 * p = "a*"
 * 输出: true
 * 解释: 因为 '*' 代表可以匹配零个或多个前面的那一个元素, 在这里前面的元素就是 'a'。因此，字符串 "aa" 可被视为 'a' 重复了一次。
 * 
 * 
 * 示例 3:
 * 
 * 输入:
 * s = "ab"
 * p = ".*"
 * 输出: true
 * 解释: ".*" 表示可匹配零个或多个（'*'）任意字符（'.'）。
 * 
 * 
 * 示例 4:
 * 
 * 输入:
 * s = "aab"
 * p = "c*a*b"
 * 输出: true
 * 解释: 因为 '*' 表示零个或多个，这里 'c' 为 0 个, 'a' 被重复一次。因此可以匹配字符串 "aab"。
 * 
 * 
 * 示例 5:
 * 
 * 输入:
 * s = "mississippi"
 * p = "mis*is*p*."
 * 输出: false
 * 
 */
class Solution {
    
    Boolean[][] mem;
    public boolean isMatch(String s, String p) {
        mem = new Boolean[s.length() + 1][p.length() + 1];
        return isMatch(s, 0, p, 0);
    }
    
    private boolean isMatch(String s, int i, String p, int j) {
        if (i == s.length() && j == p.length()) {
            return true;
        }
        if (i > s.length()) {//i到结尾，p还有可能是匹配0个
            return false;
        }
        if (j >= p.length()) {
            return false;
        }
        if (mem[i][j] != null) {
            return mem[i][j];
        }
        char pc = p.charAt(j);
        if (pc == '*') {//看继续匹配或跳过
            return mem[i][j] = isMatch(s, i, p, j - 1) || isMatch(s, i, p, j + 1);
        }
        if (j + 1 < p.length() && p.charAt(j + 1) == '*') {//下一个是*，看看匹配0个是否通过
            if (isMatch(s, i, p, j + 2)) {
                return mem[i][j] = true;
            }
        }
        if (i == s.length()) {
            return mem[i][j] = false;
        }
        char sc = s.charAt(i);
        if (pc >= 'a' && pc <= 'z') {
            if (pc == sc) {
                return mem[i][j] = isMatch(s, i + 1, p, j + 1);
            }
            return mem[i][j] = false;
        } else if (pc == '.') {
            return mem[i][j] = isMatch(s, i + 1, p, j + 1);
        }
        return mem[i][j] = false;
    }
}

