/*
 * @lc app=leetcode.cn id=300 lang=java
 *
 * [300] 最长上升子序列
 *
 * https://leetcode-cn.com/problems/longest-increasing-subsequence/description/
 *
 * algorithms
 * Medium (43.71%)
 * Likes:    406
 * Dislikes: 0
 * Total Accepted:    45.5K
 * Total Submissions: 104K
 * Testcase Example:  '[10,9,2,5,3,7,101,18]'
 *
 * 给定一个无序的整数数组，找到其中最长上升子序列的长度。
 * 
 * 示例:
 * 
 * 输入: [10,9,2,5,3,7,101,18]
 * 输出: 4 
 * 解释: 最长的上升子序列是 [2,3,7,101]，它的长度是 4。
 * 
 * 说明:
 * 
 * 
 * 可能会有多种最长上升子序列的组合，你只需要输出对应的长度即可。
 * 你算法的时间复杂度应该为 O(n^2) 。
 * 
 * 
 * 进阶: 你能将算法的时间复杂度降低到 O(n log n) 吗?
 * 
 */

// @lc code=start
class Solution {
    public int lengthOfLIS(int[] nums) {
        if (nums.length == 0) {
            return 0;
        }
        int max = 0;
        int[] tails = new int[nums.length];
        for (int num : nums) {
            int i = 0;
            int j = max;
            while (i < j) {
                int m = (i + j) / 2;
                if (num > tails[m]) {
                    i = m + 1;
                } else {
                    j = m;
                }
            }
            if (j == max) {
                max++;
            }
            tails[i] = num;
        }
        return max;
    }
}
// @lc code=end

