/*
 * @lc app=leetcode.cn id=844 lang=java
 *
 * [844] 比较含退格的字符串
 *
 * https://leetcode-cn.com/problems/backspace-string-compare/description/
 *
 * algorithms
 * Easy (50.98%)
 * Likes:    198
 * Dislikes: 0
 * Total Accepted:    41.4K
 * Total Submissions: 79K
 * Testcase Example:  '"ab#c"\n"ad#c"'
 *
 * 给定 S 和 T 两个字符串，当它们分别被输入到空白的文本编辑器后，判断二者是否相等，并返回结果。 # 代表退格字符。
 * 
 * 注意：如果对空文本输入退格字符，文本继续为空。
 * 
 * 
 * 
 * 示例 1：
 * 
 * 输入：S = "ab#c", T = "ad#c"
 * 输出：true
 * 解释：S 和 T 都会变成 “ac”。
 * 
 * 
 * 示例 2：
 * 
 * 输入：S = "ab##", T = "c#d#"
 * 输出：true
 * 解释：S 和 T 都会变成 “”。
 * 
 * 
 * 示例 3：
 * 
 * 输入：S = "a##c", T = "#a#c"
 * 输出：true
 * 解释：S 和 T 都会变成 “c”。
 * 
 * 
 * 示例 4：
 * 
 * 输入：S = "a#c", T = "b"
 * 输出：false
 * 解释：S 会变成 “c”，但 T 仍然是 “b”。
 * 
 * 
 * 
 * 提示：
 * 
 * 
 * 1 <= S.length <= 200
 * 1 <= T.length <= 200
 * S 和 T 只含有小写字母以及字符 '#'。
 * 
 * 
 * 
 * 
 * 进阶：
 * 
 * 
 * 你可以用 O(N) 的时间复杂度和 O(1) 的空间复杂度解决该问题吗？
 * 
 * 
 * 
 * 
 */

// @lc code=start
class Solution {
    public boolean backspaceCompare(String S, String T) {
        int i = S.length() - 1;
        int j = T.length() - 1;
        int bs = 0;
        int bt = 0;
        while (true) {
            while (i >= 0 && S.charAt(i) == '#') {
                bs++;
                i--;
            }
            while (i >= 0 && S.charAt(i) != '#' && bs > 0) {
                bs--;
                i--;
            }
            while (j >= 0 && T.charAt(j) == '#') {
                bt++;
                j--;
            }
            while (j >= 0 && T.charAt(j) != '#' && bt > 0) {
                bt--;
                j--;
            }

            if (i < 0 && j < 0) {
                return true;
            }
            if (i >= 0 && S.charAt(i) == '#') {
                continue;
            }
            if (j >= 0 && T.charAt(j) == '#') {
                continue;
            }
            if (i < 0 || j < 0) {
                return false;
            }
            if (S.charAt(i) != T.charAt(j)) {
                return false;
            }
            i--;
            j--;
        }
    }
}
// @lc code=end

